// #autoload
// #name = DioGrabWatcher
// #version = 0.5
// #date = 5/29/2002 4:24AM
// #status = alpha
// #author = |Rx|Diogenes
// #warrior = Diogenes
// #email = diogenes@tribalpharmacy.com
// #web = http://dioscripts.tribes-universe.com
// #description = Waypoints flag grabbers
// #include = support/player_support.cs
// #category = DioScripts
// #config = DioGWConfig

if(!isObject(DioGrabWatcher))
{
	new ScriptObject(DioGrabWatcher)
	{
		class = DioGrabWatcher;
	};
}

function DioGrabWatcherJoinTeam(%msgType, %msgString, %clientName, %teamName, %clientId, %teamId){
	if(%clientid == PlayerList.getMyID()){
		DioGrabWatcher.MyTeam = detag(%teamId); 
		deleteVariables("$DioGrabWatcher::Grabs*");
		deleteVariables("$DioGrabWatcher::WP*");
	}
}

function DioGrabWatcherGrab(%msgType, %msgString, %name, %teamName, %team, %nameBase)	{
	%team = detag(%team);
	%name = detag(%name);
	echo(%team);
	if(%team $= DioGrabWatcher.MyTeam){
		$DioGrabWatcher::Grabs[%name] = $DioGrabWatcher::Grabs[%name]++;
		if($DioGrabWatcher::Grabs[%name] >= DioGrabWatcher.magicnumber && !$DioGrabWatcher::WP[%name]){
			%targetId = PlayerList.getTargetIDByName(%name);
			%targetnum = createClientTarget(%targetId, "0 0 0");
			%targetnum.createWaypoint("FC:" @ %name);
			$ClientWaypoints.add(%Targetnum);
			$DioGrabWatcher::WP[%name] = true;
		}
	}
}

function DioGrabWatcherSetup(){
	addMessageCallback('MsgCTFFlagTaken', DioGrabWatcherGrab);
	addMessageCallback('MsgClientJoinTeam', DioGrabWatcherJoinTeam);

	if($pref::DioGrabWatcher::MagicNumber < 1)
		$pref::DioGrabWatcher::MagicNumber = 2;
		
	DioGrabWatcher.magicnumber = $pref::DioGrabWatcher::MagicNumber;
	
	new GuiControl(DioGWConfig) {
		profile = "GuiDefaultProfile";
		horizSizing = "center";
		vertSizing = "center";
		position = "0 0";
		extent = "640 480";
		minExtent = "8 8";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";

		new ShellPaneCtrl() {
			profile = "ShellPaneProfile";
			horizSizing = "center";
			vertSizing = "center";
			position = "0 0";
			extent = "272 99";
			minExtent = "48 92";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "DioGrabWatcher";
			longTextBuffer = "0";
			maxLength = "255";
			noTitleBar = "0";

			new ShellFieldCtrl() {
				profile = "ShellFieldProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "20 29";
				extent = "231 53";
				minExtent = "16 18";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
			};
			new ShellSliderCtrl(DioGWSlider) {
				profile = "ShellSliderProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "33 50";
				extent = "186 24";
				minExtent = "12 24";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				altCommand = "DioGrabWatcherSettings();";
				variable = "value";
				helpTag = "0";
				range = "1 10";
				ticks = "10";
				value = $pref::DioGrabWatcher::MagicNumber;
				usePlusMinus = "1";
			};
			new GuiTextCtrl(DioGWConfigText) {
				profile = "ShellTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "33 35";
				extent = "109 22";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				longTextBuffer = "0";
				maxLength = "255";
				value = "DioGrabWatcher - " @ $pref::DioGrabWatcher::MagicNumber @ " flag grabs before WP";
			};

		};
	};
	DioGrabWatcherSettings();
}

function DioGWConfig::onwake(){
	//nothing
}

function DioGrabWatcherSettings(){
	$pref::DioGrabWatcher::MagicNumber = mFloor(DioGWSlider.getValue());
	DioGWConfigText.setValue("DioGrabWatcher - " @ $pref::DioGrabWatcher::MagicNumber @ " flag grabs before WP");
	DioGrabWatcher.magicnumber = $pref::DioGrabWatcher::MagicNumber;
}	

if($AutoloadExecuted)
	DioGrabWatcherSetup();
